/*
 * blanco Framework
 * Copyright (C) 2004-2005 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.plugin.soap.actions;

import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import blanco.commons.io.File2StreamWrapper;
import blanco.commons.util.BlancoNameUtil;
import blanco.plugin.soap.BlancoSOAPPlugin;
import blanco.plugin.soap.editors.BlancoSOAPPluginUtil;
import blanco.soap.BlancoSoapDotNetWsdlExe;
import blanco.soap.BlancoSoapWsdl2Asmx;
import blanco.soap.BlancoSoapWsdl2CsClass;
import blanco.xsd.BlancoXsdXsdValidator;

/**
 * XSD生成を駆動するアクション
 * 
 * @author IGA Tosiki
 */
public class BlancoXsd2CsSourceGenerateAction {
    /**
     * GUIデバッグ用の低速モード。通常はfalseで運用します。
     */
    private static final boolean IS_DEBUG_SLOW = false;

    /**
     * blancoSOAPソースコード生成処理を実行します。
     * 
     * @param ifile
     *            処理対象となるファイル。
     * @param shell
     *            親シェル。
     * @param workbenchMonitor
     *            ワークベンチモニタ。
     * @param metaDir
     *            メタディレクトリ。
     * @param isRunWsdkExe
     *            wsdl.exeを実行するかどうか。
     * @param dotNetSdkDir
     *            .NET Framework SDKのディレクトリ。
     * @throws InvocationTargetException
     *             実行時例外が発生した場合。
     * @throws InterruptedException
     *             割り込み例外が発生した場合。
     */
    public static final void process(final IFile ifile, final Shell shell,
            IProgressMonitor workbenchMonitor, final String metaDir,
            final boolean isRunWsdkExe, final String dotNetSdkDir)
            throws InvocationTargetException, InterruptedException {
        if (ifile.getProject().getFolder(metaDir).exists() == false) {
            MessageDialog.openWarning(shell, "ソースコード生成", "メタディレクトリ (" + metaDir
                    + ") が存在しません。処理を中断します。");
            return;
        }

        // Eclipse 3.3 対策: begin
        // workbenchMonitorを利用することを停止しました。
        // org.eclipse.swt.SWTException: Invalid thread access が発生してしまいます。
        // Eclipse 3.3 対策: end

        try {
            // PlatformUI.getWorkbench().getProgressService()を有益と判断。
            PlatformUI.getWorkbench().getProgressService().busyCursorWhile(
                    new IRunnableWithProgress() {
                        public void run(IProgressMonitor monitor)
                                throws InvocationTargetException,
                                InterruptedException {
                            try {
                                monitor.beginTask("blancoXsdソースコード生成", 10);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask("フォルダ作成: blanco.csフォルダ");
                                final IFolder folderDirBlanco = ifile
                                        .getProject().getFolder("blanco.cs");
                                folderDirBlanco.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);
                                if (folderDirBlanco.exists() == false) {
                                    folderDirBlanco.create(true, true, monitor);
                                }

                                monitor.subTask("フォルダ作成: blanco.cs/mainフォルダ");
                                final IFolder folderDirBlancoMain = folderDirBlanco
                                        .getFolder("main");
                                // 更新は不要
                                if (folderDirBlancoMain.exists() == false) {
                                    folderDirBlancoMain.create(true, true,
                                            monitor);
                                }

                                monitor.subTask("フォルダ作成: blanco.cs.clientフォルダ");
                                final IFolder folderDirBlancoClient = ifile
                                        .getProject().getFolder(
                                                "blanco.cs.client");
                                folderDirBlanco.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);
                                if (folderDirBlancoClient.exists() == false) {
                                    folderDirBlancoClient.create(true, true,
                                            monitor);
                                }

                                monitor
                                        .subTask("フォルダ作成: blanco.cs.client/mainフォルダ");
                                final IFolder folderDirBlancoMainClient = folderDirBlancoClient
                                        .getFolder("main");
                                // 更新は不要
                                if (folderDirBlancoMainClient.exists() == false) {
                                    folderDirBlancoMainClient.create(true,
                                            true, monitor);
                                }

                                monitor.subTask("フォルダ作成: blanco.asmxフォルダ");
                                final IFolder folderDirBlancoAsmx = ifile
                                        .getProject().getFolder("blanco.asmx");
                                folderDirBlancoAsmx.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);
                                if (folderDirBlancoAsmx.exists() == false) {
                                    folderDirBlancoAsmx.create(true, true,
                                            monitor);
                                }

                                monitor.subTask("ディレクトリ: テンポラリフォルダの調整");

                                // テンポラリフォルダを一旦削除します。
                                BlancoSOAPPluginUtil.deleteFolder(ifile,
                                        monitor, "tmp/soap/xsd");
                                BlancoSOAPPluginUtil.createFolder(ifile,
                                        monitor, "tmp/soap/xsd");

                                final IFolder folderDirSoapXsd = BlancoSOAPPluginUtil
                                        .findFolder(ifile, monitor,
                                                "tmp/soap/xsd");
                                folderDirSoapXsd.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                final IFolder folderDirMetaDir = BlancoSOAPPluginUtil
                                        .findFolder(ifile, monitor, metaDir);
                                folderDirMetaDir.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);
                                final IResource[] resourcesMetaFiles = folderDirMetaDir
                                        .members();
                                for (int index = 0; index < resourcesMetaFiles.length; index++) {
                                    if (monitor.isCanceled()) {
                                        return;
                                    }
                                    if (resourcesMetaFiles[index] instanceof IFile) {
                                        final IFile fileLookMetaFile = (IFile) resourcesMetaFiles[index];
                                        if (fileLookMetaFile.getFileExtension()
                                                .equals("xsd")) {
                                            monitor
                                                    .subTask("C#.NETソースコード作成: ファイル["
                                                            + fileLookMetaFile
                                                                    .getName()
                                                            + "]の妥当性チェックを処理します ("
                                                            + (index + 1)
                                                            + "/"
                                                            + resourcesMetaFiles.length
                                                            + ")");
                                            final String fileName = BlancoNameUtil
                                                    .trimFileExtension(fileLookMetaFile
                                                            .getName());
                                            if (fileName == null) {
                                                throw new IllegalArgumentException(
                                                        "処理の過程で加工後のファイル名がnullになってしまいました。加工前のファイル名["
                                                                + fileName
                                                                + "]");
                                            }
                                            try {
                                                // XSDファイルの妥当性検証を行います。
                                                new File2StreamWrapper(
                                                        fileLookMetaFile
                                                                .getLocation()
                                                                .toFile(), null) {
                                                    protected void process(
                                                            InputStream inStream,
                                                            OutputStream outStreamIgnore)
                                                            throws Exception {
                                                        new BlancoXsdXsdValidator()
                                                                .process(
                                                                        inStream,
                                                                        fileName);
                                                    }
                                                }.run();
                                            } catch (IllegalArgumentException ex) {
                                                BlancoSOAPPlugin.log(ex);
                                                throw new IllegalArgumentException(

                                                        "ファイル["
                                                                + fileLookMetaFile
                                                                        .getName()
                                                                + "]のValueObject処理中にエラーが発生しました。処理を中断します。\n\n"
                                                                + ex.toString());
                                            }
                                        } else if (fileLookMetaFile
                                                .getFileExtension().equals(
                                                        "wsdl")) {
                                            monitor
                                                    .subTask("C#.NETソースコード作成: ファイル["
                                                            + fileLookMetaFile
                                                                    .getName()
                                                            + "]の処理をおこないます ("
                                                            + (index + 1)
                                                            + "/"
                                                            + resourcesMetaFiles.length
                                                            + ")");
                                            try {
                                                // サーバの生成。
                                                new BlancoSoapWsdl2CsClass()
                                                        .process(
                                                                fileLookMetaFile
                                                                        .getLocation()
                                                                        .toFile(),
                                                                folderDirBlanco
                                                                        .getLocation()
                                                                        .toFile(),
                                                                true);

                                                // クライアントの生成。
                                                new BlancoSoapWsdl2CsClass()
                                                        .process(
                                                                fileLookMetaFile
                                                                        .getLocation()
                                                                        .toFile(),
                                                                folderDirBlancoClient
                                                                        .getLocation()
                                                                        .toFile(),
                                                                false);

                                                if (isRunWsdkExe) {
                                                    final BlancoSoapDotNetWsdlExe wsdlexe = new BlancoSoapDotNetWsdlExe();
                                                    wsdlexe
                                                            .setDotNetSdkDir(dotNetSdkDir);
                                                    wsdlexe.setServer(true);
                                                    wsdlexe
                                                            .process(
                                                                    fileLookMetaFile
                                                                            .getLocation()
                                                                            .toFile(),
                                                                    folderDirBlanco
                                                                            .getLocation()
                                                                            .toFile());
                                                }
                                                if (isRunWsdkExe) {
                                                    // クライアント側を生成。
                                                    final BlancoSoapDotNetWsdlExe wsdlexe = new BlancoSoapDotNetWsdlExe();
                                                    wsdlexe
                                                            .setDotNetSdkDir(dotNetSdkDir);
                                                    wsdlexe.setServer(false);
                                                    wsdlexe
                                                            .process(
                                                                    fileLookMetaFile
                                                                            .getLocation()
                                                                            .toFile(),
                                                                    folderDirBlancoClient
                                                                            .getLocation()
                                                                            .toFile());
                                                }

                                                // asmxファイルの自動生成
                                                final BlancoSoapWsdl2Asmx wsdl2Asmx = new BlancoSoapWsdl2Asmx();
                                                wsdl2Asmx.process(
                                                        fileLookMetaFile
                                                                .getLocation()
                                                                .toFile(),
                                                        folderDirBlancoAsmx
                                                                .getLocation()
                                                                .toFile());
                                            } catch (IllegalArgumentException ex) {
                                                BlancoSOAPPlugin.log(ex);
                                                throw new IllegalArgumentException(

                                                        "ファイル["
                                                                + fileLookMetaFile
                                                                        .getName()
                                                                + "]のValueObject処理中にエラーが発生しました。処理を中断します。\n\n"
                                                                + ex.toString());
                                            }
                                        }
                                        if (IS_DEBUG_SLOW) {
                                            Thread.sleep(1000);
                                        }
                                    }
                                }

                                monitor.subTask("C#.NETソースコード作成");
                                monitor.worked(1);

                                monitor.subTask("フォルダ更新: blanco.csフォルダを更新");
                                monitor.worked(1);

                                folderDirBlanco.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                folderDirBlancoClient.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                folderDirBlancoAsmx.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                folderDirSoapXsd.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                if (IS_DEBUG_SLOW) {
                                    Thread.sleep(1000);
                                }
                            } catch (Exception e) {
                                // 最終防衛ライン
                                e.printStackTrace();
                                throw new InvocationTargetException(e, e
                                        .toString());
                            } catch (Error e) {
                                // 最終防衛ライン
                                e.printStackTrace();
                                throw new InvocationTargetException(e, e
                                        .toString());
                            } finally {
                                // 最後の最後では done扱いとします。
                                monitor.done();
                            }
                        }
                    });
        } catch (InvocationTargetException ex) {
            BlancoSOAPPlugin.log(ex);
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "例外が発生しました。処理を中断します。\n" + ex.getCause().toString());
            ex.printStackTrace();
        } catch (InterruptedException ex) {
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "割り込み中断例外が発生しました。処理を中断します。\n" + ex.toString());
            ex.printStackTrace();
        } catch (Exception ex) {
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "予期せぬ例外が発生しました。処理を中断します。\n" + ex.toString());
            ex.printStackTrace();
        }
    }
}